
var MagicSLRButton;
var gMagicSLRPromptsBundle;
var gMagicSLRPromptService;
var gMagicSLROfflineManager;


function hiddenSLR()
{
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);

  var prefGetSendMenu = nsPreferences.getIntPref("magicslr.GetSendMenu_state", 0);

  if (prefGetSendMenu==0)  // GetSendMenu should be complete
  {

    var hiddenIDs = ["SLR_RS_Sync_Sep", "SLR_RS_Sync_all", "SLR_RS_Sync_Flagged", "SLR_RS_Sync_Selected"];

    for( var i = 0; i < hiddenIDs.length; i++ )
    {        
      var hideID = hiddenIDs[i];
  	// Get references to the hidden elements
      var hidden=document.getElementById("hideID");
	if (!hidden) break;

  	// Remove the hidden attribute so that the label appears.
  	hidden.removeAttribute("hidden");
    }
  }
}


function MagicSLRGetMessagesForAllAccounts()
{
   try {
    var allServers = accountManager.allServers;
    for (var i=0;i<allServers.Count();i++) {
      var currentServer = allServers.GetElementAt(i).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
      var protocolinfo = Components.classes["@mozilla.org/messenger/protocol/info;1?type=" +
                           currentServer.type].getService(Components.interfaces.nsIMsgProtocolInfo);
      if (protocolinfo.canGetMessages) {
        // Get new messages now
        GetMessagesForInboxOnServer(currentServer);
      }
    }
  }
  catch(ex) {
    dump(ex + "\n");
  }
}


function MagicSLRProfileManager()
{
  var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
             .getService(Components.interfaces.nsIWindowWatcher);
  var params = Components.classes["@mozilla.org/embedcomp/dialogparam;1"]
                 .createInstance(Components.interfaces.nsIDialogParamBlock);
  
  params.SetNumberStrings(1);
  params.SetString(0, "menu");
  ww.openWindow(null, // no parent
                "chrome://communicator/content/profile/profileSelection.xul",
                null,
                "centerscreen,chrome,modal,titlebar",
                params);
  
  // Here, we don't care about the result code
  // that was returned in the param block.
}


// --- Check for unsent messages ---
function CheckForUnsentMessages()
{
  try
  {
    var am = Components.classes["@mozilla.org/messenger/account-manager;1"]
                 .getService(Components.interfaces.nsIMsgAccountManager);
    var msgSendlater = Components.classes["@mozilla.org/messengercompose/sendlater;1"]
                 .getService(Components.interfaces.nsIMsgSendLater);
    var identitiesCount, allIdentities, currentIdentity, numMessages, msgFolder;

    if(am) { 
      allIdentities = am.allIdentities;
      identitiesCount = allIdentities.Count();
      for (var i = 0; i < identitiesCount; i++) {
        currentIdentity = allIdentities.QueryElementAt(i, Components.interfaces.nsIMsgIdentity);
        msgFolder = msgSendlater.getUnsentMessagesFolder(currentIdentity);
        if(msgFolder) {
          // if true, descends into all subfolders 
          numMessages = msgFolder.getTotalMessages(false);
          if(numMessages > 0) return true;
        }
      } 
    }
  }
  catch(ex) {
  }
  return false;
}


// ----- Init OfflineManager
function InitMagicSLROfflineManager()
{
	if(!gMagicSLROfflineManager)
	{
		gMagicSLROfflineManager = Components.classes["@mozilla.org/messenger/offline-manager;1"]                 
			.getService(Components.interfaces.nsIMsgOfflineManager);
	}
}


// --- Init nsIPromptService & strings ---
function InitMagicSLRPrompts()
{
  if(!gMagicSLRPromptService) {
    gMagicSLRPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    gMagicSLRPromptService = gMagicSLRPromptService.QueryInterface(Components.interfaces.nsIPromptService);
  }
  if (!gMagicSLRPromptsBundle) 
    gMagicSLRPromptsBundle = document.getElementById("magicslrPrompts");
}


// --- prompt for sending messages while shuting down, and shut down ---
function PromptMagicSLRSendMessages()
{
  if (gMagicSLRPromptService) {
    var buttonPressed = gMagicSLRPromptService.confirm(window, 
                          gMagicSLRPromptsBundle.getString('sendMessagesWindowTitle'), 
                          gMagicSLRPromptsBundle.getString('sendMessagesLabel'));
    	if(buttonPressed == 1) 
    	{
		SendNow();
    	}
  }
}


// --- prompt for going online and sending messages while shuting down, and shut down ---
function PromptMagicSLRGoOnline()
{
  if (gMagicSLRPromptService) {
    var buttonPressed = gMagicSLRPromptService.confirm(window, 
                          gMagicSLRPromptsBundle.getString('askOnlineWindowTitle'), 
                          gMagicSLRPromptsBundle.getString('askOnlineLabel'));
    	if(buttonPressed == 1) 
    	{
		SendNow();
    	}
  }
}


// --- prompt to wait before shut down ---
function PromptMagicSLRWaitBefore()
{
	if (gMagicSLRPromptService)
	{
		var buttonPressed = gMagicSLRPromptService.alert(window, 
	                      gMagicSLRPromptsBundle.getString('waitBeforeWindowTitle'), 
	                      gMagicSLRPromptsBundle.getString('waitBeforeLabel'));
	}
}


// --- online? ---
function CheckOnlineSLR()
{
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                         .getService(Components.interfaces.nsIIOService);
  return (!ioService.offline);
}


// ----- Senden und bei Bedarf vorher online gehen -----
function SendNow()
{
	if(!CheckOnlineSLR())
		gMagicSLROfflineManager.goOnline(false, false, msgWindow);					
	goDoCommand('cmd_sendUnsentMsgs');
	PromptMagicSLRWaitBefore();
}


// ----- Hauptfunktion beim ShutDown -----
function SendUnsentBeforeShutDown()
{
	var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);

	InitMagicSLROfflineManager();
	InitMagicSLRPrompts();

	var prefSendUnsentMessages = nsPreferences.getIntPref("magicslr.shutdown_state", 0);
	var prefGoOnline = nsPreferences.getIntPref("magicslr.goonline_state", 0);

	if(CheckForUnsentMessages())  // if there are unsent messages
	{
		if(CheckOnlineSLR())   // we are online
		{
			switch(prefSendUnsentMessages)
			{
			   	case 2:    // do not send unsent messages, so we can quit now
			      		break;
			    	case 1:    // send unsent messages automatically
					SendNow();
			     		break;
		   		case 0:    // ask, if we should send unsent messages
		   			PromptMagicSLRSendMessages();
				     	break;
			}
		}
		else    //we are offline, so we've to check the related prefs
		{
			switch(prefGoOnline)
			{
				case 0:   // ask, if we should go online
					if(prefSendUnsentMessages==2)    // do not send > quit 
					{
						break;
					}
					PromptMagicSLRGoOnline();   // ask, if we should send and go online
					break;
				case 1:   // automatically go online
					if(prefSendUnsentMessages==0)
					{
						PromptMagicSLRGoOnline();   // ask, if we should send
						break;
					}
					if(prefSendUnsentMessages==1)   // automatically send unsent
					{
						SendNow();
						break;
					}
					break;
				case 2:   // do not go online, so we can quit now
					break;
			}
		}
	}
}

// ----- Funktion des Buttons Get/Send bzw. Get all-----
function MagicSLRGetSend(MagicSLRButton)
{
	var prefGetSendButtonSend = nsPreferences.getIntPref("magicslr.GetSendButton_Send", 0);
	var prefGetSendButtonPass = nsPreferences.getIntPref("magicslr.GetSendButton_Pass", 0);

	switch(prefGetSendButtonSend)
	{
		case 0:   // Send=Yes
			if((prefGetSendButtonPass==0) && (MagicSLRButton=='GetSend'))       // Ask not for passwords
			{
				goDoCommand('cmd_getMsgsForAuthAccounts');
				goDoCommand('cmd_sendUnsentMsgs');
				break;
			}
			else if((prefGetSendButtonPass==1) && (MagicSLRButton=='GetSend'))  // Ask for passwords
			{
				MagicSLRGetMessagesForAllAccounts();
				goDoCommand('cmd_sendUnsentMsgs');
				break;
			}
		case 1:    // Send=No
			if(prefGetSendButtonPass==0)       // Ask not for passwords
			{
				goDoCommand('cmd_getMsgsForAuthAccounts');
				break;
			}
			else if(prefGetSendButtonPass==1)  // Ask for passwords
			{
				MagicSLRGetMessagesForAllAccounts();
				break;
			}		
	}
}
